diff -NurpP --minimal linux-3.0/drivers/media/video/omap3isp/isp.h torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/isp.h
--- linux-3.0/drivers/media/video/omap3isp/isp.h	2011-06-22 15:09:21.000000000 +0000
+++ torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/isp.h	2011-10-18 04:06:23.000000000 +0000
@@ -139,6 +139,10 @@ struct isp_reg {
  *		3 - CAMEXT[13:6] -> CAM[7:0]
  * @clk_pol: Pixel clock polarity
  *		0 - Non Inverted, 1 - Inverted
+ * @hs_pol: Horizontal synchronization polarity
+ *		0 - Active high, 1 - Active low
+ * @vs_pol: Vertical synchronization polarity
+ *		0 - Active high, 1 - Active low
  * @bridge: CCDC Bridge input control
  *		ISPCTRL_PAR_BRIDGE_DISABLE - Disable
  *		ISPCTRL_PAR_BRIDGE_LENDIAN - Little endian
@@ -147,6 +151,8 @@ struct isp_reg {
 struct isp_parallel_platform_data {
 	unsigned int data_lane_shift:2;
 	unsigned int clk_pol:1;
+	unsigned int hs_pol:1;
+	unsigned int vs_pol:1;
 	unsigned int bridge:4;
 };
 
diff -NurpP --minimal linux-3.0/drivers/media/video/omap3isp/ispccdc.c torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispccdc.c
--- linux-3.0/drivers/media/video/omap3isp/ispccdc.c	2011-06-22 15:09:21.000000000 +0000
+++ torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispccdc.c	2011-10-18 04:06:23.000000000 +0000
@@ -31,6 +31,7 @@
 #include <linux/dma-mapping.h>
 #include <linux/mm.h>
 #include <linux/sched.h>
+#include <linux/slab.h>
 #include <media/v4l2-event.h>
 
 #include "isp.h"
@@ -1148,6 +1149,8 @@ static void ccdc_configure(struct isp_cc
 	omap3isp_configure_bridge(isp, ccdc->input, pdata, shift);
 
 	ccdc->syncif.datsz = depth_out;
+	ccdc->syncif.hdpol = pdata ? pdata->hs_pol : 0;
+	ccdc->syncif.vdpol = pdata ? pdata->vs_pol : 0;
 	ccdc_config_sync_if(ccdc, &ccdc->syncif);
 
 	/* CCDC_PAD_SINK */
@@ -1691,7 +1694,7 @@ static int ccdc_subscribe_event(struct v
 	if (sub->type != V4L2_EVENT_OMAP3ISP_HS_VS)
 		return -EINVAL;
 
-	return v4l2_event_subscribe(fh, sub);
+	return v4l2_event_subscribe(fh, sub, OMAP3ISP_CCDC_NEVENTS);
 }
 
 static int ccdc_unsubscribe_event(struct v4l2_subdev *sd, struct v4l2_fh *fh,
@@ -2162,7 +2165,6 @@ static int ccdc_init_entities(struct isp
 	sd->grp_id = 1 << 16;	/* group ID for isp subdevs */
 	v4l2_set_subdevdata(sd, ccdc);
 	sd->flags |= V4L2_SUBDEV_FL_HAS_EVENTS | V4L2_SUBDEV_FL_HAS_DEVNODE;
-	sd->nevents = OMAP3ISP_CCDC_NEVENTS;
 
 	pads[CCDC_PAD_SINK].flags = MEDIA_PAD_FL_SINK;
 	pads[CCDC_PAD_SOURCE_VP].flags = MEDIA_PAD_FL_SOURCE;
@@ -2257,8 +2259,6 @@ int omap3isp_ccdc_init(struct isp_device
 	ccdc->syncif.fldout = 0;
 	ccdc->syncif.fldpol = 0;
 	ccdc->syncif.fldstat = 0;
-	ccdc->syncif.hdpol = 0;
-	ccdc->syncif.vdpol = 0;
 
 	ccdc->clamp.oblen = 0;
 	ccdc->clamp.dcsubval = 0;
diff -NurpP --minimal linux-3.0/drivers/media/video/omap3isp/ispccp2.c torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispccp2.c
--- linux-3.0/drivers/media/video/omap3isp/ispccp2.c	2011-06-22 15:09:21.000000000 +0000
+++ torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispccp2.c	2011-10-18 04:06:23.000000000 +0000
@@ -30,6 +30,7 @@
 #include <linux/module.h>
 #include <linux/mutex.h>
 #include <linux/uaccess.h>
+#include <linux/regulator/consumer.h>
 
 #include "isp.h"
 #include "ispreg.h"
@@ -163,6 +164,9 @@ static void ccp2_if_enable(struct isp_cc
 	struct isp_pipeline *pipe = to_isp_pipeline(&ccp2->subdev.entity);
 	int i;
 
+	if (enable && ccp2->vdds_csib)
+		regulator_enable(ccp2->vdds_csib);
+
 	/* Enable/Disable all the LCx channels */
 	for (i = 0; i < CCP2_LCx_CHANS_NUM; i++)
 		isp_reg_clr_set(isp, OMAP3_ISP_IOMEM_CCP2, ISPCCP2_LCx_CTRL(i),
@@ -186,6 +190,9 @@ static void ccp2_if_enable(struct isp_cc
 				    ISPCCP2_LC01_IRQENABLE,
 				    ISPCCP2_LC01_IRQSTATUS_LC0_FS_IRQ);
 	}
+
+	if (!enable && ccp2->vdds_csib)
+		regulator_disable(ccp2->vdds_csib);
 }
 
 /*
@@ -1137,6 +1144,9 @@ error:
  */
 void omap3isp_ccp2_cleanup(struct isp_device *isp)
 {
+	struct isp_ccp2_device *ccp2 = &isp->isp_ccp2;
+
+	regulator_put(ccp2->vdds_csib);
 }
 
 /*
@@ -1151,14 +1161,27 @@ int omap3isp_ccp2_init(struct isp_device
 
 	init_waitqueue_head(&ccp2->wait);
 
-	/* On the OMAP36xx, the CCP2 uses the CSI PHY1 or PHY2, shared with
+	/*
+	 * On the OMAP34xx the CSI1 receiver is operated in the CSIb IO
+	 * complex, which is powered by vdds_csib power rail. Hence the
+	 * request for the regulator.
+	 *
+	 * On the OMAP36xx, the CCP2 uses the CSI PHY1 or PHY2, shared with
 	 * the CSI2c or CSI2a receivers. The PHY then needs to be explicitly
 	 * configured.
 	 *
 	 * TODO: Don't hardcode the usage of PHY1 (shared with CSI2c).
 	 */
-	if (isp->revision == ISP_REVISION_15_0)
+	if (isp->revision == ISP_REVISION_2_0) {
+		ccp2->vdds_csib = regulator_get(isp->dev, "vdds_csib");
+		if (IS_ERR(ccp2->vdds_csib)) {
+			dev_dbg(isp->dev,
+				"Could not get regulator vdds_csib\n");
+			ccp2->vdds_csib = NULL;
+		}
+	} else if (isp->revision == ISP_REVISION_15_0) {
 		ccp2->phy = &isp->isp_csiphy1;
+	}
 
 	ret = ccp2_init_entities(ccp2);
 	if (ret < 0)
diff -NurpP --minimal linux-3.0/drivers/media/video/omap3isp/ispccp2.h torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispccp2.h
--- linux-3.0/drivers/media/video/omap3isp/ispccp2.h	2011-06-22 15:09:21.000000000 +0000
+++ torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispccp2.h	2011-10-18 04:06:23.000000000 +0000
@@ -81,6 +81,7 @@ struct isp_ccp2_device {
 	struct isp_interface_mem_config mem_cfg;
 	struct isp_video video_in;
 	struct isp_csiphy *phy;
+	struct regulator *vdds_csib;
 	unsigned int error;
 	enum isp_pipeline_stream_state state;
 	wait_queue_head_t wait;
diff -NurpP --minimal linux-3.0/drivers/media/video/omap3isp/ispstat.c torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispstat.c
--- linux-3.0/drivers/media/video/omap3isp/ispstat.c	2011-06-22 15:09:22.000000000 +0000
+++ torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispstat.c	2011-10-18 04:06:23.000000000 +0000
@@ -1032,7 +1032,6 @@ static int isp_stat_init_entities(struct
 	snprintf(subdev->name, V4L2_SUBDEV_NAME_SIZE, "OMAP3 ISP %s", name);
 	subdev->grp_id = 1 << 16;	/* group ID for isp subdevs */
 	subdev->flags |= V4L2_SUBDEV_FL_HAS_EVENTS | V4L2_SUBDEV_FL_HAS_DEVNODE;
-	subdev->nevents = STAT_NEVENTS;
 	v4l2_set_subdevdata(subdev, stat);
 
 	stat->pad.flags = MEDIA_PAD_FL_SINK;
@@ -1050,7 +1049,7 @@ int omap3isp_stat_subscribe_event(struct
 	if (sub->type != stat->event_type)
 		return -EINVAL;
 
-	return v4l2_event_subscribe(fh, sub);
+	return v4l2_event_subscribe(fh, sub, STAT_NEVENTS);
 }
 
 int omap3isp_stat_unsubscribe_event(struct v4l2_subdev *subdev,
diff -NurpP --minimal linux-3.0/drivers/media/video/omap3isp/ispvideo.c torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispvideo.c
--- linux-3.0/drivers/media/video/omap3isp/ispvideo.c	2011-06-22 15:09:22.000000000 +0000
+++ torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispvideo.c	2011-10-18 04:06:23.000000000 +0000
@@ -695,7 +695,6 @@ isp_video_querycap(struct file *file, vo
 	strlcpy(cap->driver, ISP_VIDEO_DRIVER_NAME, sizeof(cap->driver));
 	strlcpy(cap->card, video->video.name, sizeof(cap->card));
 	strlcpy(cap->bus_info, "media", sizeof(cap->bus_info));
-	cap->version = ISP_VIDEO_DRIVER_VERSION;
 
 	if (video->type == V4L2_BUF_TYPE_VIDEO_CAPTURE)
 		cap->capabilities = V4L2_CAP_VIDEO_CAPTURE | V4L2_CAP_STREAMING;
diff -NurpP --minimal linux-3.0/drivers/media/video/omap3isp/ispvideo.h torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispvideo.h
--- linux-3.0/drivers/media/video/omap3isp/ispvideo.h	2011-06-22 15:09:22.000000000 +0000
+++ torvalds-linux-v3.1-rc10/drivers/media/video/omap3isp/ispvideo.h	2011-10-18 04:06:23.000000000 +0000
@@ -27,7 +27,6 @@
 #define OMAP3_ISP_VIDEO_H
 
 #include <linux/v4l2-mediabus.h>
-#include <linux/version.h>
 #include <media/media-entity.h>
 #include <media/v4l2-dev.h>
 #include <media/v4l2-fh.h>
@@ -35,7 +34,7 @@
 #include "ispqueue.h"
 
 #define ISP_VIDEO_DRIVER_NAME		"ispvideo"
-#define ISP_VIDEO_DRIVER_VERSION	KERNEL_VERSION(0, 0, 1)
+#define ISP_VIDEO_DRIVER_VERSION	"0.0.2"
 
 struct isp_device;
 struct isp_video;
diff -NurpP --minimal linux-3.0/drivers/media/video/ov2640.c torvalds-linux-v3.1-rc10/drivers/media/video/ov2640.c
--- linux-3.0/drivers/media/video/ov2640.c	2011-04-03 18:51:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/drivers/media/video/ov2640.c	2011-10-18 04:06:23.000000000 +0000
@@ -1031,16 +1031,9 @@ static int ov2640_video_probe(struct soc
 	const char *devname;
 	int ret;
 
-	/*
-	 * we must have a parent by now. And it cannot be a wrong one.
-	 * So this entire test is completely redundant.
-	 */
-	if (!icd->dev.parent ||
-	    to_soc_camera_host(icd->dev.parent)->nr != icd->iface) {
-		dev_err(&client->dev, "Parent missing or invalid!\n");
-		ret = -ENODEV;
-		goto err;
-	}
+	/* We must have a parent by now. And it cannot be a wrong one. */
+	BUG_ON(!icd->parent ||
+	       to_soc_camera_host(icd->parent)->nr != icd->iface);
 
 	/*
 	 * check and show product ID and manufacturer ID
